//
// automatically generated by spin2cpp v1.03 on Sat Mar 23 14:14:22 2013
// spin2cpp --ccode MPU6050_XS.spin 
//
#include <propeller.h>
#include "MPU6050_XS.h"
#include <math.h>


#ifdef __GNUC__
#define INLINE__ static inline
#define PostEffect__(X, Y) __extension__({ int32_t tmp__ = (X); (X) = (Y); tmp__; })
#else
#define INLINE__ static
static int32_t tmp__;
#define PostEffect__(X, Y) (tmp__ = (X), (X) = (Y), tmp__)
#define waitcnt(n) _waitcnt(n)
#define locknew() _locknew()
#define lockret(i) _lockret(i)
#define lockset(i) _lockset(i)
#define lockclr(i) _lockclr(i)
#define coginit(id, code, par) _coginit((unsigned)(par)>>2, (unsigned)(code)>>2, id)
#define cognew(code, par) coginit(0x8, (code), (par))
#define cogstop(i) _cogstop(i)
#endif

#define GYRO_NBR_OF_AXES 3
#define GYRO_X_SIGN      (-1)
#define GYRO_Y_SIGN      (-1)
#define GYRO_Z_SIGN      (-1)
#define GYRO_NBR_OF_AXES            3

#define GYRO_VARIANCE_BASE        4000
#define GYRO_VARIANCE_THRESHOLD_X (GYRO_VARIANCE_BASE)
#define GYRO_VARIANCE_THRESHOLD_Y (GYRO_VARIANCE_BASE)
#define GYRO_VARIANCE_THRESHOLD_Z (GYRO_VARIANCE_BASE)
/**
 * Set ACC_WANTED_LPF1_CUTOFF_HZ to the wanted cut-off freq in Hz.
 * The highest cut-off freq that will have any affect is fs /(2*pi).
 * E.g. fs = 350 Hz -> highest cut-off = 350/(2*pi) = 55.7 Hz -> 55 Hz
 */
#define IMU_ACC_WANTED_LPF_CUTOFF_HZ  10
/**
 * Attenuation should be between 1 to 256.
 *
 * f0 = fs / 2*pi*attenuation ->
 * attenuation = fs / 2*pi*f0
 */
#define IMU_ACC_IIR_LPF_ATTENUATION (IMU_UPDATE_FREQ / (2 * 3.1415 * IMU_ACC_WANTED_LPF_CUTOFF_HZ))
#define IMU_ACC_IIR_LPF_ATT_FACTOR  (int)(((1<<IIR_SHIFT) / IMU_ACC_IIR_LPF_ATTENUATION) + 0.5)
#define IMU_NBR_OF_BIAS_SAMPLES  128
#define IMU_DEG_PER_LSB_CFG   (float)((2 * 1000.0) / 65536.0)
#define IMU_G_PER_LSB_CFG     (float)((2 * 8) / 65536.0)
#define IMU_1G_RAW            (int16_t)(1.0 / (float)((2 * 8) / 65536.0))
#define GYRO_MIN_BIAS_TIMEOUT_MS (CLKFREQ)   //M2T(1*1000)


// Pre-calculated values for accelerometer alignment
float cosPitch;
float sinPitch;
float cosRoll;
float sinRoll;

static MPU6050_XS thisobj;

typedef struct
{
  Axis3i16   bias;
  bool       isBiasValueFound;
  bool       isBufferFilled;
  Axis3i16*  bufHead;
  Axis3i16   buffer[IMU_NBR_OF_BIAS_SAMPLES];
} BiasObj;



BiasObj    gyroBias;
BiasObj    accelBias;
int32_t    varianceSampleTime;
Axis3i16   gyroMpu;
Axis3i16   accelMpu;
Axis3i16   accelLPF;
Axis3i16   accelLPFAligned;
Axis3i16   mag;
Axis3i32   accelStoredFilterValues;



static void imuCalculateVarianceAndMean(BiasObj* bias, Axis3i32* varOut, Axis3i32* meanOut);
static  void       imuBiasInit(BiasObj* bias);
static  void       MPU6050_XS_ImuAccAlignToGravity(Axis3i16* in, Axis3i16* out);
static  int32_t    MPU6050_XS_Computetimes(void);



static uint8_t dat[] = {
  0xf0, 0xaf, 0xbd, 0xa0, 0xd7, 0xb2, 0xbd, 0xa0, 0x04, 0xae, 0xfd, 0x80, 0xd7, 0xb4, 0xbd, 0xa0, 
  0x04, 0xae, 0xfd, 0x80, 0xd7, 0xb6, 0xbd, 0xa0, 0x04, 0xae, 0xfd, 0x80, 0xd7, 0xb0, 0xbd, 0xa0, 
  0x04, 0xae, 0xfd, 0x80, 0xd7, 0xb8, 0xbd, 0xa0, 0x04, 0xae, 0xfd, 0x80, 0xd7, 0xba, 0xbd, 0xa0, 
  0x04, 0xae, 0xfd, 0x80, 0xd7, 0xbc, 0xbd, 0xa0, 0xf4, 0xd8, 0xbd, 0xa0, 0xf1, 0xd9, 0xbd, 0x80, 
  0x00, 0xd8, 0xfd, 0xf8, 0x83, 0x20, 0xfd, 0x5c, 0x56, 0xc6, 0xfc, 0x5c, 0xf1, 0xd7, 0xbd, 0xa0, 
  0xea, 0xd6, 0xbd, 0x80, 0x1f, 0xaa, 0xfc, 0x5c, 0xd8, 0xbe, 0x3d, 0x08, 0xd9, 0xc0, 0x3d, 0x08, 
  0xda, 0xc2, 0x3d, 0x08, 0xdb, 0xc4, 0x3d, 0x08, 0xdc, 0xc6, 0x3d, 0x08, 0xdd, 0xc8, 0x3d, 0x08, 
  0xde, 0xca, 0x3d, 0x08, 0xea, 0xd6, 0xbd, 0xf8, 0x15, 0x00, 0x7c, 0x5c, 0x3b, 0xe0, 0xfd, 0xa0, 
  0xfc, 0xde, 0xbd, 0xa0, 0x64, 0xe0, 0xfc, 0x5c, 0xe8, 0xf4, 0xbd, 0xa0, 0x00, 0xea, 0x7d, 0x61, 
  0xbf, 0xac, 0xfd, 0x5c, 0xbf, 0xac, 0xfd, 0x5c, 0xe8, 0xf2, 0x3d, 0x61, 0xe9, 0xf2, 0xbd, 0x70, 
  0xf9, 0xc6, 0xbd, 0xa0, 0xe8, 0xf4, 0xbd, 0xa0, 0x00, 0xea, 0x7d, 0x61, 0xbf, 0xac, 0xfd, 0x5c, 
  0xbf, 0xac, 0xfd, 0x5c, 0xe8, 0xf2, 0x3d, 0x61, 0xe9, 0xf2, 0xbd, 0x70, 0xf9, 0xc8, 0xbd, 0xa0, 
  0xe8, 0xf4, 0xbd, 0xa0, 0x00, 0xea, 0x7d, 0x61, 0xbf, 0xac, 0xfd, 0x5c, 0xbf, 0xac, 0xfd, 0x5c, 
  0xe8, 0xf2, 0x3d, 0x61, 0xe9, 0xf2, 0xbd, 0x70, 0xf9, 0xca, 0xbd, 0xa0, 0xe8, 0xf4, 0xbd, 0xa0, 
  0x00, 0xea, 0x7d, 0x61, 0xbf, 0xac, 0xfd, 0x5c, 0xbf, 0xac, 0xfd, 0x5c, 0xe8, 0xf2, 0x3d, 0x61, 
  0xe9, 0xf2, 0xbd, 0x70, 0xf9, 0xbe, 0xbd, 0xa0, 0xe8, 0xf4, 0xbd, 0xa0, 0x00, 0xea, 0x7d, 0x61, 
  0xbf, 0xac, 0xfd, 0x5c, 0xbf, 0xac, 0xfd, 0x5c, 0xe8, 0xf2, 0x3d, 0x61, 0xe9, 0xf2, 0xbd, 0x70, 
  0xf9, 0xc0, 0xbd, 0xa0, 0xe8, 0xf4, 0xbd, 0xa0, 0x00, 0xea, 0x7d, 0x61, 0xbf, 0xac, 0xfd, 0x5c, 
  0xbf, 0xac, 0xfd, 0x5c, 0xe8, 0xf2, 0x3d, 0x61, 0xe9, 0xf2, 0xbd, 0x70, 0xf9, 0xc2, 0xbd, 0xa0, 
  0xe8, 0xf4, 0xbd, 0xa0, 0x00, 0xea, 0x7d, 0x61, 0xbf, 0xac, 0xfd, 0x5c, 0x01, 0xea, 0x7d, 0x61, 
  0xbf, 0xac, 0xfd, 0x5c, 0xe8, 0xf2, 0x3d, 0x61, 0xe9, 0xf2, 0xbd, 0x70, 0xf9, 0xc4, 0xbd, 0xa0, 
  0x9c, 0x4c, 0xfd, 0x5c, 0x00, 0x00, 0x7c, 0x5c, 0xfc, 0xde, 0xbd, 0xa0, 0x14, 0xe0, 0xfd, 0xa0, 
  0x04, 0xdc, 0xfd, 0xa0, 0x71, 0x04, 0xfd, 0x5c, 0x1b, 0xe0, 0xfd, 0xa0, 0x10, 0xdc, 0xfd, 0xa0, 
  0x71, 0x04, 0xfd, 0x5c, 0x1c, 0xe0, 0xfd, 0xa0, 0x10, 0xdc, 0xfd, 0xa0, 0x71, 0x04, 0xfd, 0x5c, 
  0x6b, 0xe0, 0xfd, 0xa0, 0x03, 0xdc, 0xfd, 0xa0, 0x71, 0x04, 0xfd, 0x5c, 0x00, 0x00, 0x7c, 0x5c, 
  0x91, 0x36, 0xfd, 0x5c, 0xef, 0xf2, 0xbd, 0xa0, 0x80, 0xf4, 0xfd, 0xa0, 0xa7, 0x7c, 0xfd, 0x5c, 
  0xf0, 0xf2, 0xbd, 0xa0, 0x80, 0xf4, 0xfd, 0xa0, 0xa7, 0x7c, 0xfd, 0x5c, 0x91, 0x36, 0xfd, 0x5c, 
  0xef, 0xf2, 0xbd, 0xa0, 0x01, 0xf2, 0xfd, 0x68, 0x80, 0xf4, 0xfd, 0xa0, 0xa7, 0x7c, 0xfd, 0x5c, 
  0x00, 0x00, 0x7c, 0x5c, 0x91, 0x36, 0xfd, 0x5c, 0xef, 0xf2, 0xbd, 0xa0, 0x80, 0xf4, 0xfd, 0xa0, 
  0xa7, 0x7c, 0xfd, 0x5c, 0xf2, 0xf0, 0xbd, 0xa0, 0xf1, 0xf1, 0xbd, 0x80, 0x00, 0xf0, 0xfd, 0xf8, 
  0xf0, 0xf2, 0xbd, 0xa0, 0x80, 0xf4, 0xfd, 0xa0, 0xa7, 0x7c, 0xfd, 0x5c, 0xf2, 0xf0, 0xbd, 0xa0, 
  0xf1, 0xf1, 0xbd, 0x80, 0x00, 0xf0, 0xfd, 0xf8, 0xee, 0xf2, 0xbd, 0xa0, 0x80, 0xf4, 0xfd, 0xa0, 
  0xa7, 0x7c, 0xfd, 0x5c, 0x9c, 0x4c, 0xfd, 0x5c, 0x00, 0x00, 0x7c, 0x5c, 0xf7, 0xec, 0xbf, 0x64, 
  0x09, 0xf6, 0xfd, 0xa0, 0xf2, 0xf0, 0xbd, 0xa0, 0xf1, 0xf1, 0xbd, 0x80, 0xf6, 0xe8, 0xbf, 0x64, 
  0xf6, 0xec, 0xbf, 0x68, 0xf3, 0xf0, 0xbd, 0xf8, 0xf6, 0xe8, 0xbf, 0x68, 0xf6, 0xec, 0xbf, 0x68, 
  0xf6, 0xec, 0xbf, 0x64, 0xf2, 0xf0, 0xbd, 0xf8, 0xf2, 0xef, 0x3d, 0x62, 0x87, 0xf6, 0xe9, 0xe4, 
  0x00, 0x00, 0x7c, 0x5c, 0xf6, 0xe8, 0xbf, 0x68, 0xf6, 0xec, 0xbf, 0x68, 0xf7, 0xe8, 0xbf, 0x68, 
  0xf7, 0xec, 0xbf, 0x68, 0xf3, 0xf0, 0xbd, 0xa0, 0xf1, 0xf1, 0xbd, 0x80, 0xf2, 0xf0, 0xbd, 0xf8, 
  0xf7, 0xe8, 0xbf, 0x64, 0x00, 0xf0, 0xfd, 0xf8, 0xf6, 0xe8, 0xbf, 0x64, 0x00, 0x00, 0x7c, 0x5c, 
  0xf6, 0xe8, 0xbf, 0x68, 0xf3, 0xf0, 0xbd, 0xa0, 0xf1, 0xf1, 0xbd, 0x80, 0xf2, 0xf0, 0xbd, 0xf8, 
  0xf7, 0xe8, 0xbf, 0x68, 0xf2, 0xf0, 0xbd, 0xf8, 0xf6, 0xec, 0xbf, 0x64, 0xf2, 0xf0, 0xbd, 0xf8, 
  0xf7, 0xec, 0xbf, 0x64, 0x00, 0xf0, 0xfd, 0xf8, 0x00, 0x00, 0x7c, 0x5c, 0x08, 0xf6, 0xfd, 0xa0, 
  0xf2, 0xf0, 0xbd, 0xa0, 0xf1, 0xf1, 0xbd, 0x80, 0xf1, 0xf0, 0xbd, 0xf8, 0xfa, 0xf2, 0x3d, 0x62, 
  0xf7, 0xec, 0xab, 0x68, 0xf7, 0xec, 0x97, 0x64, 0xf3, 0xf0, 0xbd, 0xf8, 0xf6, 0xe8, 0xbf, 0x68, 
  0xf2, 0xf0, 0xbd, 0xf8, 0xf6, 0xe8, 0xbf, 0x64, 0x01, 0xf4, 0xfd, 0x20, 0xaa, 0xf6, 0xfd, 0xe4, 
  0xf7, 0xec, 0xbf, 0x64, 0xf3, 0xf0, 0xbd, 0xf8, 0xf6, 0xe8, 0xbf, 0x68, 0xf2, 0xf0, 0xbd, 0xf8, 
  0xf2, 0xef, 0x3d, 0x61, 0xf6, 0xe8, 0xbf, 0x64, 0xf7, 0xe8, 0xbf, 0x64, 0xf7, 0xec, 0xbf, 0x68, 
  0x10, 0xf4, 0xfd, 0x24, 0x00, 0xf0, 0xfd, 0xf8, 0x00, 0x00, 0x7c, 0x5c, 0x08, 0xf6, 0xfd, 0xa0, 
  0xf7, 0xec, 0xbf, 0x64, 0xf2, 0xf0, 0xbd, 0xa0, 0xf1, 0xf1, 0xbd, 0x80, 0xf3, 0xf0, 0xbd, 0xf8, 
  0xf6, 0xe8, 0xbf, 0x68, 0xf2, 0xf0, 0xbd, 0xf8, 0xf2, 0xef, 0x3d, 0x62, 0xf6, 0xe8, 0xbf, 0x64, 
  0xfa, 0xf2, 0x95, 0x68, 0xfa, 0xf2, 0xa9, 0x64, 0x01, 0xf4, 0xfd, 0x20, 0xc3, 0xf6, 0xfd, 0xe4, 
  0xf1, 0xf0, 0xbd, 0xf8, 0xf7, 0xe8, 0xb3, 0x68, 0xf7, 0xe8, 0x8f, 0x64, 0xf7, 0xec, 0xbf, 0x68, 
  0xf3, 0xf0, 0xbd, 0xf8, 0xf6, 0xe8, 0xbf, 0x68, 0xf2, 0xf0, 0xbd, 0xf8, 0xf6, 0xe8, 0xbf, 0x64, 
  0xf7, 0xe8, 0xbf, 0x64, 0x00, 0xf0, 0xfd, 0xf8, 0x00, 0x00, 0x7c, 0x5c, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x80, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xe2, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0xd0, 0x00, 0x00, 0x00, 
};
int32_t MPU6050_XS_Start(int32_t _sda, int32_t _scl, int32_t _int, int32_t _ado, int32_t _acp)
{
  int32_t Status = 0;
  DIRA |= (1<<_ado);
  OUTA = ((OUTA & (~(1 << _ado))) | ((_acp & 0x1) << _ado));
  MPU6050_XS_Computetimes();
  ((int32_t *)&dat[984])[0] = (1 << _scl);
  ((int32_t *)&dat[988])[0] = (1 << _sda);
  Status = (thisobj.Cog = (cognew((int32_t)(&(*(int32_t *)&dat[0])), (int32_t)(&thisobj.Rx)) + 1));
  waitcnt(CNT+CLKFREQ/10);
  imuBiasInit(&gyroBias);
  waitcnt(CNT+CLKFREQ/10);
  imuBiasInit(&accelBias);
  varianceSampleTime = -GYRO_MIN_BIAS_TIMEOUT_MS + 1;
  cosPitch = cos(0.0 * M_PI/180); // Add Load of config for Trim Pitch and Roll 
  sinPitch = sin(0.0 * M_PI/180);
  cosRoll = cos(0.0 * M_PI/180);
  sinRoll = sin(0.0 * M_PI/180);  
  return Status;
}

int32_t MPU6050_XS_Computetimes(void)
{
  ((int32_t *)&dat[964])[0] = (((CLKFREQ / 10000) * 350) / 100000);
  ((int32_t *)&dat[968])[0] = (((CLKFREQ / 10000) * 1300) / 100000);
  ((int32_t *)&dat[972])[0] = (((CLKFREQ / 10000) * 600) / 100000);
  ((int32_t *)&dat[976])[0] = (CLKFREQ / 100000);
  return 0;
}



static void MPU6050_XS_ImuAccIIRLPFilter(Axis3i16* in, Axis3i16* out, Axis3i32* storedValues, int32_t attenuation)
{
  out->x = iirLPFilterSingle(in->x, attenuation, &storedValues->x);
  out->y = iirLPFilterSingle(in->y, attenuation, &storedValues->y);
  out->z = iirLPFilterSingle(in->z, attenuation, &storedValues->z);
}

static void MPU6050_XS_ImuAddBiasValue(BiasObj* bias, Axis3i16* dVal)
{
  bias->bufHead->x = dVal->x;
  bias->bufHead->y = dVal->y;
  bias->bufHead->z = dVal->z;
  bias->bufHead++;

  if (bias->bufHead >= &bias->buffer[IMU_NBR_OF_BIAS_SAMPLES])
  {
    bias->bufHead = bias->buffer;
    bias->isBufferFilled = true;
    
  }
}


static bool MPU6050_XS_ImuFindBiasValue(BiasObj* bias)
{
  bool foundBias = false;
  
  if (bias->isBufferFilled)
  {
    Axis3i32 variance;
    Axis3i32 mean;

   imuCalculateVarianceAndMean(bias, &variance, &mean);

    if (variance.x < GYRO_VARIANCE_THRESHOLD_X && variance.y < GYRO_VARIANCE_THRESHOLD_Y && variance.z < GYRO_VARIANCE_THRESHOLD_Z &&(varianceSampleTime + GYRO_MIN_BIAS_TIMEOUT_MS < CNT))
    {
      varianceSampleTime = CNT;
      bias->bias.x = mean.x;
      bias->bias.y = mean.y;
      bias->bias.z = mean.z;
      foundBias = true;
      bias->isBiasValueFound = true;
    }
  }

  return foundBias;
}



void MPU6050_XS_Imu6Read(Axis3f* gyroOut, Axis3f* accOut)
{
  accelMpu.x = thisobj.Ax;
  accelMpu.y = thisobj.Ay;
  accelMpu.z = thisobj.Az;
  gyroMpu.x = thisobj.Rx;
  gyroMpu.y = thisobj.Ry;
  gyroMpu.z = thisobj.Rz;
  
  MPU6050_XS_ImuAddBiasValue(&gyroBias, &gyroMpu);
  if (!accelBias.isBiasValueFound)
  {
  
  MPU6050_XS_ImuAddBiasValue(&accelBias, &accelMpu);
  }
  if (!gyroBias.isBiasValueFound)
  { 
    //printf("Adding base value to GYRO\n");
    MPU6050_XS_ImuFindBiasValue(&gyroBias);
    if (gyroBias.isBiasValueFound)
    {
        
    }
  }

#ifdef IMU_TAKE_ACCEL_BIAS
  if (gyroBias.isBiasValueFound && !accelBias.isBiasValueFound)
  {
    Axis3i32 mean;
    imuCalculateBiasMean(&accelBias, &mean);
    accelBias.bias.x = mean.x;
    accelBias.bias.y = mean.y;
    accelBias.bias.z = mean.z - IMU_1G_RAW;
    accelBias.isBiasValueFound = true;
  }
#endif
    
   
  MPU6050_XS_ImuAccIIRLPFilter(&accelMpu, &accelLPF, &accelStoredFilterValues,IMU_ACC_IIR_LPF_ATT_FACTOR);
  MPU6050_XS_ImuAccAlignToGravity(&accelLPF, &accelLPFAligned);

  gyroOut->x = (gyroMpu.x - gyroBias.bias.x) * IMU_DEG_PER_LSB_CFG;
  gyroOut->y = (gyroMpu.y - gyroBias.bias.y) * IMU_DEG_PER_LSB_CFG;
  gyroOut->z = (gyroMpu.z - gyroBias.bias.z) * IMU_DEG_PER_LSB_CFG;
  accOut->x = (accelLPFAligned.x - accelBias.bias.x) * IMU_G_PER_LSB_CFG;
  accOut->y = (accelLPFAligned.y - accelBias.bias.y) * IMU_G_PER_LSB_CFG;
  accOut->z = (accelLPFAligned.z - accelBias.bias.z) * IMU_G_PER_LSB_CFG;
   
}

static void  MPU6050_XS_ImuAccAlignToGravity(Axis3i16* in, Axis3i16* out)
{
  Axis3i16 rx;
  Axis3i16 ry;

  // Rotate around x-axis
  rx.x = in->x;
  rx.y = in->y * cosRoll - in->z * sinRoll;
  rx.z = in->y * sinRoll + in->z * cosRoll;

  // Rotate around y-axis
  ry.x = rx.x * cosPitch - rx.z * sinPitch;
  ry.y = rx.y;
  ry.z = -rx.x * sinPitch + rx.z * cosPitch;

  out->x = ry.x;
  out->y = ry.y;
  out->z = ry.z;
}


static void imuCalculateVarianceAndMean(BiasObj* bias, Axis3i32* varOut, Axis3i32* meanOut)
{
  uint32_t i;
  int32_t sum[GYRO_NBR_OF_AXES] = {0};
  int64_t sumSq[GYRO_NBR_OF_AXES] = {0};

  for (i = 0; i < IMU_NBR_OF_BIAS_SAMPLES; i++)
  {
    sum[0] += bias->buffer[i].x;
    sum[1] += bias->buffer[i].y;
    sum[2] += bias->buffer[i].z;
    sumSq[0] += bias->buffer[i].x * bias->buffer[i].x;
    sumSq[1] += bias->buffer[i].y * bias->buffer[i].y;
    sumSq[2] += bias->buffer[i].z * bias->buffer[i].z;
  }

  varOut->x = (sumSq[0] - ((int64_t)sum[0] * sum[0]) / IMU_NBR_OF_BIAS_SAMPLES);
  varOut->y = (sumSq[1] - ((int64_t)sum[1] * sum[1]) / IMU_NBR_OF_BIAS_SAMPLES);
  varOut->z = (sumSq[2] - ((int64_t)sum[2] * sum[2]) / IMU_NBR_OF_BIAS_SAMPLES);

  meanOut->x = sum[0] / IMU_NBR_OF_BIAS_SAMPLES;
  meanOut->y = sum[1] / IMU_NBR_OF_BIAS_SAMPLES;
  meanOut->z = sum[2] / IMU_NBR_OF_BIAS_SAMPLES;

  
}

static void imuBiasInit(BiasObj* bias)
{
  bias->isBufferFilled = true;
  bias->bufHead = bias->buffer;
}


